#ifndef QIMAGEWIDGET_H
#define QIMAGEWIDGET_H

#include <QWidget>
#include <QPixmap>
#include <QMargins>

class QImageWidget : public QWidget
{
  Q_OBJECT
public:
  explicit QImageWidget(QWidget *parent = 0);
  ~QImageWidget();
private:
  //картинка для отображения
  QPixmap _originalImage;
  //текст отображаемый при незагруженной картинке
  QString _noImageMessage;
  //минимальная ширина рамки
  int _margin;
  QMargins _margins;
  //цвет фона (рамки)
  QColor _backgroundColor;
  QRect actualImageRect();
  //пересчитать размеры отступов
  void updateMargins();
public:
  //задать картинку для отображения
  void setPixmap(QPixmap pixmap);
  QPixmap pixmap(){ return _originalImage; }

  int margin(){ return _margin; }
signals:
  void pixmapChanged();
  void marginChanged();
public slots:
  void setMargin(int value);
protected:  
  //обработчик события двойного щелчка мыши
  virtual void mouseDoubleClickEvent(QMouseEvent *event);
  //отрисовка виджета
  virtual void paintEvent(QPaintEvent *);
};

#endif // QIMAGEWIDGET_H
